"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMiddleware = exports.WARRANT_IGNORE_ID = void 0;
const warrant_node_1 = require("@warrantdev/warrant-node");
var warrant_node_2 = require("@warrantdev/warrant-node");
Object.defineProperty(exports, "WARRANT_IGNORE_ID", { enumerable: true, get: function () { return warrant_node_2.WARRANT_IGNORE_ID; } });
function createAuthorizeRoute(client, getParam, getUserId, onAuthorizeFailure) {
    return (objectType, objectIdParam, relation) => {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            const objectId = getParam(req, objectIdParam);
            const userId = getUserId(req);
            if (userId === null) {
                onAuthorizeFailure(req, res);
                return;
            }
            if (yield client.isAuthorized(objectType, objectId, relation, userId.toString())) {
                if (next) {
                    next();
                }
                return;
            }
            onAuthorizeFailure(req, res);
        });
    };
}
function createMiddleware(config) {
    const client = new warrant_node_1.Client(config.clientKey);
    let getParam = (req, paramName) => req.params[paramName];
    let onAuthorizeFailure = (req, res) => res.sendStatus(401);
    if (config.getParam) {
        getParam = config.getParam;
    }
    if (config.onAuthorizeFailure) {
        onAuthorizeFailure = config.onAuthorizeFailure;
    }
    return createAuthorizeRoute(client, getParam, config.getUserId, onAuthorizeFailure);
}
exports.createMiddleware = createMiddleware;
